# thread-chunks
A Python package for performing memory-intensive computations in parallel using chunks and checkpointing.

[![Unit Tests](https://github.com/Christopher-K-Long/thread-chunks/actions/workflows/test-python-package.yml/badge.svg)](https://github.com/Christopher-K-Long/thread-chunks/actions/workflows/test-python-package.yml)

## Installation

The Python package can be installed with pip as follows:
```bash
pip install thread-chunks
```

The PyPI page can be found here: [https://pypi.org/project/thread-chunks](https://pypi.org/project/thread-chunks).

### Requirements:

Python >= 3.7

Packages:

- [ray](https://www.ray.io/)
- [tqdm](https://tqdm.github.io/)
- [saveable-objects](https://saveable-objects.readthedocs.io/)

## Documentation

Documentation including worked examples can be found at: [https://thread-chunks.readthedocs.io/](https://thread-chunks.readthedocs.io/).

## Source Code

Source code can be found at: [https://github.com/Christopher-K-Long/thread-chunks](https://github.com/Christopher-K-Long/thread-chunks).


## Version and Changes

The current version is [`1.0.5`](ChangeLog.md#release-105). Please see the [Change Log](ChangeLog.md) for more
details.